%define current_version 0.08.018

Summary: Stub-Proxy File System
Name: spfs
Version: %{current_version}
Release:        1%{?dist}
License: GPLv3
Group: System Environment/Base
URL: https://git.sw.ru/projects/VZS/repos/spfs/
Source0: %{name}-%{current_version}.tar.bz2
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: fuse-devel
BuildRequires: libcap-devel
BuildRequires: libnl3-devel
ExclusiveArch: x86_64

%description
Stub-Proxy File System allows to replace opened files from underneath of
running process.
Required to CRIU to be able to migrate NFS mount points.

%prep
%setup -q

%build
autoreconf -fi
%configure CPPFLAGS='-I /usr/include/libnl3'
make %{?_smp_mflags}

%install
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_sbindir}/%{name}
%{_sbindir}/%{name}-client
%{_sbindir}/%{name}-manager

%changelog
* Mon Oct 10 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.018
 - ptrace: fix ax register value check for "in system call" status (#PSBM-53384)

* Fri Oct 07 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.017
 - swapfd: sync all the private file mappings (#PSBM-53303)
 - Makefile: remove explicit path to libnl3 headers from flags
 - autoconf.sh: new helper to configure and build with libnl3
 - configure: add check for libnl3/netlink/msg.h header
 - configure: add check for sys/capability.h header

* Thu Oct 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.016
 - swapfd: check, that mapping is accessible ater replace
 - swapfd: mem_read helper introduced
 - swapfd: open_pid_mem helper introduced

* Thu Oct 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.015
 - manager: check that private file mappings content is equal after copy
 - manager: copy content of writable mappings only (#PSBM-53249)

* Wed Oct 05 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.014
 - manager: copy swapped pages for private mappings (#PSBM-53161)

* Tue Oct 04 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.013
 - manager: expose process state if seize has failed (#PSBM-53092)
 - manager: expose process internals in case detach has failed
 - swapfd: create a helper for ptrace detach

* Fri Sep 30 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.012
 - manager: remove per-process share_resources flag
 - manager: do not detach from a task even if it doesn't use resources

* Thu Sep 29 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.011
 - manager: do not duplicate OVZ id per SPFS instance
 - manager: aling debug print for better output log
 - manager: restore cwd on return from SPFS context
 - manager: spfs context leaving helper introduced
 - manager: do not duplicate manager namespaces descriptors numbers
 - manager: mgr_work_dir helper introduced

* Thu Sep 29 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.010
 - manager: skip resources swap handlers call if nothing to do
 - manager: do not detach from a task, if it doesn't need resources swap (#PSBM-52883)
 - manager: use add/del_parasite helper
 - ptrace: simplify "in syscall" check
 - ptrace: fix error prints in fd sending helpers
 - swapfd: Add errno print to recvmsg()
 - manager: fix error print in transfer_local_fd

* Wed Sep 28 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.09
 - ptrace: adjust ip in case of process was traped in syscall (#PSBM-52809)
 - manager: add debug to fd transfer helper
 - swapfd: Add errno print to sendmsg()
 - vz: increase spfs exit timeout to 20 seconds

* Tue Sep 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.08
 - manager: detach from process on release (#PSBM-52700)

* Fri Sep 23 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.07
 - magaer: revert multiple integration of parasite

* Mon Aug 08 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.06
 - manager: detach from process after examine and attach again for swap (#PSBM-50800)
 - swapfd: return error from destroy_parasite_ctl if failed
 - processes: add/del_parasite helpers introduced
 - swap: do not postpone exe link swap
 - process: remove empty process from the list early
 - processes: inject parasite just before process examening
 - manager: reduce spfs log to NOTICE level

* Fri Jul 29 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.05
 - processes: fix size check in fixup_source_path

* Fri Jul 29 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.04
 - unix sockets: fix possible write beyond memory border in unix_bind_socket
 - shm: simplify shmem data pointer assignment
 - namespaces: initialize return code in set_namespaces
 - xattr: fix dereference of freed xattr in spfs_removexattr
 - unix-sockets: do not close socket in unix_listen_socket
 - unix_sockets: fix typo in error print in unix_bind_socket
 - trees: fix null pointer derefernce on error path in collect_fd
 - swapfd: fix various leaks on error paths in set_parasite_ctl
 - swapfd: fix close of invalit file descriptors in copy_private_content
 - swap: fix handler check in process_do_swap_handler
 - manager: fix uninitialized resulting variables usage in replace_resources
 - manager: unlock cgroup in any case (including error) in replace_resources
 - replace: fix fork switch
 - processes: initialize path to empty array in collect_process_cwd_root
 - processes: initialize return varibale in iterate_dir_name
 - processes: check source size in fixup_source_path
 - processes: check, that readlink returned non-empty path
 - processes: close fd info stream in parse_fdinfo
 - manager: use xtoi instead of atol for all 32-bit variables
 - util: xatoi helper introduced
 - util: make xatol_base static
 - manager: lseek freezer state fd instead of reopening in freezer_set_state
 - file_obj: fix leaked fd in case of fifo_file_fill error in fifo_file_open
 - manager: check unlink result in cleanup_spfs_mount

* Tue Jul 26 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.03
 - vz: add static/seccomp_strict to tests list (#PSBM-50020)

* Tue Jul 26 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.02
 - swapfd: Suspend seccomp while changing resources
 - swapfd: Parse seccomp state

* Mon Jul 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.01
 - vz: move static/unlink_mmap02 to supported list (#PSBM-49205)
 - swapfd: Test for private content copying
 - swapfd: Copy only present pages of private mappings
 - swapfd: Fail copy_private_content() if size is not aligned
 - swapfd: Use pread() and pwrite() in copy_private_content()
 - swapfd: Make available /proc/pid/pagemap file

* Mon Jul 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.08.00
 - vz: add socket tests to supported list (#PSBM-47017)
 - manager: support for unix sockets added
 - porcesses tries
 - porcesses: some precursor work to handle sockets
 - manager: unix sockets facility introduced
 - trees: add sockets tree and helpers
 - file_obj: early_open operation callback introduced
 - file_obj: always unlink path if silly-renamed
 - manager: fd_skip_fast helper introduced
 - manager: some swap debug cleanup
 - manager: small nits here and there
 - manager: use get_file_obj to collect fs
 - manager: use get_file_obj to collect exe link
 - manager: remove obsolete file object helpers
 - manager: use get_file_obj to collect file mappings
 - manager: use get_file_obj to collect file descriptors
 - manager: new file object related helpers introduced
 - manager: drop process_info argument from is_mnt_file and is_mnt_map
 - manager: cleanup create_map_obj usage
 - manager: move create_file_obj to file_obj.c
 - manager: move handle_sillyrenamed to link_remap.c
 - manager: export fixup_source_path
 - manager: include <stdbool.h> to processes.h
 - util: fix sillyrenamed_path int case no slash is present in path
 - manager: netlink diag interface support introduced
 - parasite: keep service socket inode on parasite_ctl structure
 
* Fri Jul 22 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.06
 - manager: disable timestamp print in signal handler
 - log: add timestamp print control toggle

* Wed Jul 13 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.05
 - manager: close spfs namespaces after environment cleanup

* Tue Jul 12 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.04
 - manager: do not detach from processes on resources release

* Tue Jul 12 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.03
 - manager: always cleanup spfs directory on its exit
 - manager: improve startup logging a bit
 - vz: update unsupported tests list
 - manager: fix spfs release on repalced exit or master was killed
 - manager: cleanup messages log level
 - log: print file and line in error messages
 - processes: pass received file descriptor to create_file_obj
 - vz: stop command sequence execution in case of error
 - processes: keep received file fd while collecting
 - processes: split collect_process_fd

* Thu Jul 07 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.02
 - spfs: remove bogus error print from gateway_real_path
 - vz: toss tests a bit

* Wed Jul 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.01
 - swap: remove excessive debug print from do_swap_exe_resources
 - trees: destroy file object on cleanup
 - manager: fix unmount of SPFS in case of error in mount_spfs()
 - manager: unmount spfs wokr directory unconditionally
 - vz: increase wait for spfs exit timeout to 10 seconds
 - link_remap: fix and simplify links deletion

* Wed Jul 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.07.00
 - manager: added support for unlinked files (#PSBM-47074)
 - vz: add "unlinked files" tests to tests list
 - vz: add support for multiple sequential jobs to nfs_tests.sh
 - vz: set running_tests to test_list in empty in nfs_tests.sh
 - vz: make "kill" faster in nfs_tests.sh
 - vz: fix "test is running" check
 - repalce: added TODO comment how to replace monut point properly
 - processes: add support for "link-remapped" files
 - processes: improve error message in transform_path
 - trees: fix memory leak in collect_path
 - manager: new "link_remap" facility introduced
 - file_obj: destroy_fd_obj helper introduced
 - trees: simplify collect_map_fd interface
 - processes.h: remove redundant struct replace_fd declaration
 - swapfd: select only private mappings for syscall injection
 - processes: add "replaced" tag to fd and map structures
 - trees: rename collect_map_fd internals
 - trees: hide replace_fd structure in trees.c
 - processes: collect only unique fs
 - processes: collect "exe" object with maps
 - processes: collect only unique maps
 - trees: collect_mm helper introduced
 - trees: fix NULL pointer dereference in collect_fd_table
 - trees: return pid of the fd owner from fd_table_exists
 - processes: use create_file_obj to collect mappings
 - processes: split collect_process_fd
 - trees: simplify collect_fs_struct prototype
 - trees: pass file object to collect_fd
 - processes: rename map_open_mode into map_open_flags
 - processes: rename release/destroy functions
 - processes: rename "mfd" into "pm"
 - file_obj: pass "void *file_obj" to create_fd_obj
 - processes.h: align structures
 - processes: rename create_file_obj into create_fd_obj
 - swap: change exe link after all other resources have changed
 - processes: improve fixup_source_path
 - processes: small optimisation to get_fd_info
 - spfs: check link_remap attribute for any file
 - manager: spfs_link_remap helper introduced
 - manager: simplify do_replace_spfs a bit
 - util: sillyrenamed_path helper introduced
 - manager: pass source mount reference to replace routine
 - manager: carry spfs reference during replacements
 - replace: collect process pid on spfs info structure
 - manager: return handler result from spfs_manager_handle_packet
 - manager; rename mounts_info_s into replace_info_s
 - manager: rename orig_ns_fds info mgr_ns_fds
 - manager: move cleanup_spfs_mount to context.c
 - manager: update_spfs_info helper introduced
 - replace: use generic examine_processes instead of deducated helpers
 - processes: export examine_processes
 - processes: treat mounts_info object as const
 - replace: remove unused ns_pid from __replace_resources declaration

* Mon Jun 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.19
 - processes: carry original process state during replacement
 - swapfd: Add debug print of used mapping (Kirill Tkhai <ktkhai@virtuozzo.com>)
 - swapfd: Pull SIGSTOP handling from criu (Kirill Tkhai <ktkhai@virtuozzo.com>)

* Fri Jun 24 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.18
 - manager: do not stat mountpoint in init_mount_info

* Thu Jun 23 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.17
 - replace: use context namespaces instead opening new in do_replace_resources
 - namespaces: treat ns_fds as const in set_namespaces
 - manager: ctx_ns_fds helper introduced
 - manager: close spfs namespaces upon deletion
 - trees: release fifo paths on trees destroy
 - processes: destroy processes object trees on release
 - processes: destroy processes objects on release
 - processes: release process maps in case of error
 - processes: release process fds in case of error
 - processes: pass fd_info_s to process_add_fd instead of it's parts
 - vz: fix process search in vz/nfs_test.sh
 - scripts: add more useful logic to nfs_test
 - processes: remove "unlinked" from fd_info_s as unused
 - autogen.sh: add "x" bit to owner

* Wed Jun 22 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.16
 - swap: fix root and cwd checks in do_swap_process_fs
 - replace: fix code execution in case of error in do_replace_resources

* Wed Jun 22 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.15
 - swapfd: remove redundant code pieces and debug
 - swap: pass file pos to swapfd routines
 - processes: collect file offset during fd parsing
 - manager: remove excessive debug
 - swapfd: format debug
 - manager: remove mappings collecting from swapfd.c
 - manager: remove unused code from swapfd.c
 - manager: use swam_map helper for mappings
 - manager: swap_map helper introduced
 - manager: collect all mapping attributes

* Tue Jun 21 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.14
 - manager: use new swap_{fds,maps,exe,cwd,root} helpers
 - manager: swap_{fds,maps,exe,cwd,root} helpers introduced
 - manager: remove debug print from get_fd_flags
 - vz: some improvements to nfs_test
 - swapfd: Do not force a change of mappings during fd change
 - swapfd: Print error message in case of memfd_create() fail

* Tue Jun 21 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.13
 - manager: split resources replacement into thre different functions
 - manager: remove obsolete and outdated fifo code
 - vz: make nfs_test.sh executable
 - vz: add additional cleanup after tests to nfs_test.sh
 - vz: improve test script output
 - vz: improve nfs test script

* Fri Jun 17 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.12
 - swapfd: Pull compat mode of parasite from criu

* Thu Jun 16 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.11
 - manager: provide O_CLOEXEC to fd swap routine
 - swapfd: Allow to fcntl::F_SETFD
 - swapfd: Check retval in change_fd()
 - vz: nfs_tests script added

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.10
 - utils: strip_deleted() helper introduced
 - manager: ressurect get_fd_flags and use it to obtain file flags
 - manager: improve error prints in files opening
 - manager: fix print typo in iterate_dir_name
 - spfs: improve gateway prints
 - spfs: do not remove xattrs for hidden files on file release
 - spfs: take link remap attribute into account when path is hidden
 - spfs: fix attrbutes comparison in find_xattr

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.9
 - spfs: fix debug print condition in spfs_getxattr
 - manager: colelct map file open from from /proc/<pid>/map_files

* Wed Jun 15 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.8
 - manager: teporary patch to fix fifo migration

* Fri Jun 10 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.7
 - manager: remove freezer open_cgroup_state helper
 - manager: cleanup resources replace helpers

* Fri Jun 10 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.6
 - manager: drop redundant "ns_list" option from mount command
 - manager: remove unused join_one_namespace helper
 - manager: use set_namespaces instead of join_namespaces
 - manager: replace spfs mounts without ct_run macro
 - manager: mount target wihtout using ct_run macro
 - manager: prepare and cleanup spfs environment by using join_spfs_context
 - manager: pass ns fds to __replace_resources
 - manager: join_spfs_context helper introduced
 - manager: split enter_spfs_context into namespaces and chroot parts
 - manager: move mount-related code to mount.c
 - manager: cleanup interface functions
 - namespaces: treat empty ns_mask as error in set_namespaces
 - namespaces: open namespaces with O_CLOEXEC
 - manager: create all spfs-related object in child on mount
 - manager: pass string agruments as consts to mount_spfs
 - manager: store init namespaces and pass to SPFS info structure
 - namespaces: remove unused change_namespaces helper
 - manager: store ns fds on spfs structure
 - processes: collect fd wisely
 - gateway: return spfs xattr if match
 - spfs: xattrs support introduced
 - list.h: include libio.h

* Thu Jun 09 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.5
 - processes: use fd_info_s contents in collect_process_fd
 - processe: get_fd_info helper inroduced
 - file object: discover process mode outside create_file_obj
 - processes: small cleanup to is_mnt_file
 - utils: unlinked_path helper introduced
 - spfs: do not treat gateway file operation result as error
 - spfs: handle only existent cur_wm in set_work_mode

* Tue Jun 07 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.4
 - processes: pass process info to is_mnt_file helper
 - pie-util-fd.h: include stdbool.h and include/ptrace.h
 - ptrace.h: drop bool declaration
 - processes: skip anonymous map examining
 - manager: infect processes right after seize
 - manager: seize processes before examining
 - processes: rename processes_collection_s into mounts_info_s
 - processes: collect_processes helper introduced
 - processes: rename collect_*_processes into examine_processes_by_*

* Mon Jun 06 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.3
 - manager: collect process root path string
 - swapfd: Use transfer_local_fd() in change_cwd()
 - swapfd: Chroot after chdir on given cwd
 - swapfd: Implement and use transfer_local_fd()
 - swapfd: Implement fchdir_seized()
 - swapfd: Implement close_seized()
 - swapfd: Export set_parasite_ctl() and destroy_parasite_ctl()
 - swapfd: Fully support seized send_fd() and recv_fd()
 - swapfd: Implement sendmsg_seized() and recvmsg_seized()
 - swapfd: Refactor recv_fd()
 - swapfd: Refactor send_fd()
 - swapfd: Cleanup: use mmap_seized()
 - swapfd: Bind local socket
 - swapfd: Cleanup rename parasite_ctl::addr{,len} to remote_addr{,len}
 - swapfd: Add chroot support

* Fri Jun 03 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.2
 - manager: mount spfs with "-o no_remote_lock"

* Wed Jun 01 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.1
 - manager: fix typo in error print in prepare_mount_env_ct

* Wed Jun 01 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.1
 - manager: fix typo in error print in prepare_mount_env_ct

* Tue May 31 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.06.0
 - manager: print fd open flags in collect_process_fd
 - manager: collect fifo file to avoid multiple content restore
 - manager: collect_fifo() helper introduced
 - manager: "fill" callback for fifo introduced
 - manager: remove get_target_fd() helper
 - manager: fifo file object added
 - manager: "file object" introduced
 - soruces: move namespace code to src/namespaces.c

* Mon May 30 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.3
 - manager: move process need replace check to separated function

* Mon May 30 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.2
 - manager: improve debug output
 - util: simplify create_dir helper
 - manager: toss fd open code a bit
 - print: print_on_level_ts introduced
 - print: remove print_on_level_va declaration
 - manager: check either process is kthread in actor instead of loop
 - manager: try to find search fd table before fd collecting

* Fri May 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.1
 - manager: collect map fd which parsing processes info
 - manager: map fd tree introduced
 - manager: collect map files via /proc/<pid>/maps
 - manager: split read link and actual fix of the path to open
 - manager: fix print typo in iterate_pids_list_name

* Fri May 27 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.05.0
 - manager: ignore collect process fs struct is shared
 - manager: fs tree introduced
 - manager: split collecting of process struct fs and exe
 - manager: split process_env into fs struct and exe fd
 - manager: do not collect process files if fd table is shared
 - manager: fd table tree introduced
 - manager: move kcmp code to separated helper kcmp()
 - manager: set 10 sec timeout for freezer and print in case of timed out
 - manager: rename add_fd_to_tree into collect_process_fd
 - manager: rename fd_tree.* into trees.*
 - manager: include list.h into processes.h
 - manager: rename root into fd_tree_root in fd_tree.c
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Thu May 26 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.04.0
 - manager: do not collect process files if fd table is shared
 - manager: fd table tree introduced
 - manager: move kcmp code to separated helper kcmp()
 - manager: set 10 sec timeout for freezer and print in case of timed out
 - manager: rename add_fd_to_tree into collect_process_fd
 - manager: rename fd_tree.* into trees.*
 - manager: include list.h into processes.h
 - manager: rename root into fd_tree_root in fd_tree.c
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.03.2
 - manager: unmount source mountpoint right after replacement and redirecting
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.03.1
 - futex: fix wrong treatment of syscall(SYS_futex, ...) result
 - futex: return 0 from futex_wake in case of success
 - manager: "replace" mode introduced
 - spfs: use futex helpers instead of plain syscall in mode change helpers
 - sources: futex-related operation moved to src/futex.c
 - manager: move spfs creation into create_spfs_info helper

* Wed May 25 2016 Konstantin Volkov <wolf@virtuozzo.com> 0.03.0
 - manager: reopen freezer state file on each state check (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: trim '\n" from current freezer state in freezer_set_state (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: return actual result in spfs_freeze_and_lock (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: try to rollback freezer state in case of set error (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: wait for freeze cgroup changed the state (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: freeze processes in replace_resources (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: convert mount paths to canonical view (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: open map file with correct access mode (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: adjust patch by source mount in is_mnt_fd (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: fix strsep usage (Stanislav Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: do not try to manage namepaces without pid (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: "switch" command added to interface (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: make repalce fully independent from spfs internals (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)
 - manager: cleanup and rename processes fd info (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: move all spfs-related code to spfs.c (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: make replace interfaces more abstract (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: move cgroup pids read routine to freeze.c (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: untie processes info from spfs (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: "mount" object introduced (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: rename mount.{c,h} into replace.{c.h} (Stanislav Kinsburskiy
<skinsbursky@virtuozzo.com>)
 - manager: set SIG_CHLD handle to SIG_DFL in mount replace handler (Stanislav
Kinsburskiy <skinsbursky@virtuozzo.com>)

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.2
 - manager: lazily unmount spfs working directory
 - manager: do not close fd in move_to_cgroup_fd

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.1
 - manager: do not close fd in move_to_cgroup_fd

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.02.0
 - Makefile: make swapfd "noinst" program
 - spec: fix repo path

* Thu May 19 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.01.5
 - sources: remove spfs-change-mode.sh
 - spec: fix repo path

* Wed May 18 2016 Stanislav Kinsburskiy <skinsbursky@virtuozzo.com> 0.01.4
 - manager: try to unmount spfs working directory few times before give up

* Mon May 16 2016 Andrey Bondrov <abondrov@virtuozzo.com> 0.01-2
- Add swapfd and spfs-change-mode.sh to package files

* Wed May 04 2016 Andrey Bondrov <abondrov@virtuozzo.com> 0.01-1
- Initial package
